# Schlumberger
# Copyright 2019 Schlumberger.  All rights reserved in Schlumberger authored and generated code (including the selection and arrangement of the source code base regardless of the authorship of individual files), but not including any copyright interest(s) owned by a third party related to source code or object code authored or generated by non-Schlumberger personnel.
# This source code includes Schlumberger confidential and/or proprietary information and may include Schlumberger trade secrets.  Any use, disclosure and/or reproduction is prohibited unless authorized in writing.
#

from pyspark.sql import SparkSession
from pyspark import SparkConf
from pyspark.sql import SQLContext
from pyspark.sql import Row
from gcloud import storage
import os.path
from pathlib import Path
import os
import itertools
import pandas as pa
from pandas.api.types import is_numeric_dtype
import numpy as np
import time
import argparse
import aiohttp
import time
import random
import asyncio
import argparse
import datetime
import lasio
from pyspark.sql.types import IntegerType, DoubleType, StringType, StructType, StructField
import pathlib
import string


if __name__ == "__main__":
    print(f"#| CURVE COUNT - start")

    parser = argparse.ArgumentParser()
    parser.add_argument("--bucketname")
    parser.add_argument("--blobprefix")
    parser.add_argument("--gcsaccount")
  
    args= parser.parse_args()
    bucketname=args.bucketname
    blobprefix=args.blobprefix
    gcsaccount = args.gcsaccount
    # hpda-gcs-mptc-external-1-hpdaext1.json
  
    print(f"#| bucketname={bucketname}")
    print(f"#| blobprefix={blobprefix}")
    print(f"#| gcsaccount={gcsaccount}")
 

    def get_storage_service() :
        json_path = os.getenv(f"HPDA_GCS_JSON_PATH",gcsaccount)
        os.environ["GOOGLE_APPLICATION_CREDENTIALS"] = json_path
        storage_service = storage.client.Client()
        return storage_service

    try:
        # .config('spark.executor.memory','2g')\
        spark = SparkSession\
            .builder\
            .appName("Python")\
            .config('spark.hadoop.mapreduce.fileoutputcommitter.algorithm.version','2')\
            .getOrCreate()

        sc = spark.sparkContext    

      
        print(f"#| CURVE-count - list_blob - start")
        cli= get_storage_service()
        print(f"#| CURVE-count - list_blob - get_storage_service() - ok")
        bucket = cli.bucket(bucketname)    
        list_all =  list(bucket.list_blobs())  # prefix = blobprefix -- not used
        lasfiles = [ x.name for x in list_all if ".las" in x.name.lower() ]   
        print(f"#| CURVE-count - list_blob - done")

        # --------------- Have to wait for cluster to initialize
        t_0 = time.time()
        t_1 = time.time()
        expected_executor= int(spark.sparkContext.getConf().get("spark.executor.instances"))

        while t_1-t_0 < 1200 :
            nb_executor=  spark.sparkContext._jsc.sc().getExecutorMemoryStatus().size()-1       # ICI nombre de worker
            print(f"#| study-loader - available executor {nb_executor} /  {expected_executor}")
            if (nb_executor >= expected_executor) :
                print(f"#| study-loader - available executor {nb_executor} >=  {expected_executor} - took {t_1-t_0}s - ok")
                break
            time.sleep(10)
            t_1 = time.time()

        print(f"number of LAS : {len(lasfiles)}")

        def variable_count(filename):
            try : 
                cli = get_storage_service()   
                bucket = cli.bucket(bucketname)       
                blob = bucket.blob(filename)           
                datastr = blob.download_as_string(client = cli)               
                lf = lasio.read(datastr.decode('latin-1'),ignore_header_errors=True,ignore_data=True)
                return lf.df().columns
            except: 
                return ["Error"]
        

        ############################## Travail ####################################

        # Conversion LAS-parquet pour un traitement plus simple après

        try : 
            cli = get_storage_service()
            bucket = cli.bucket(bucketname)
            print("bucket ok")
        except :
            print("erreur setup bucket")

        t_global = time.time()  # Temps total

        # Arguments (A setup en appel si on a le temps)
        generate_parquets = False
        q1 = False
        generate_curves_tables = False
        q2 = True

        print("nombre de parquets actuels : ", len(os.listdir('/p/SLM_files/parquets')))

        if generate_parquets :
            t_gp = time.time()  # Temps de generation
            for f in lasfiles :

                if not (f.replace('.las', '') in os.listdir('/p/SLM_files/parquets')) : # Pour 'OOMKilled with exit code 137'
                    
                    print(f + ' a traiter ...')
                    blob = bucket.blob(f)
                    datastr = blob.download_as_string(client = cli)
                    # print("lecture...")
                    try :
                        lasio_file = lasio.read(datastr.decode('latin-1'), ignore_header_errors=True) #lasio.LAS
                        # print("....lecture ok")
                        df_data = lasio_file.df() # Pandas DF
                        # print(df_data.head())
                        df_data.reset_index(drop=False, inplace=True)

                        df_data.to_parquet('/p/SLM_files/parquets/{}'.format(f.replace('.las', '')))
                        print(" ... fichier "+f+" traité")

                    except :
                        print("fichier "+ f + " non traité")
            print("Temps pour generer les fichiers parquets : ", time.time() - t_gp, "s avec", nb_executor,"worker")


        if q1 :
            ## Question 1 ##
            # Compute
            print("Calcul")
            t1_c = time.time()  # Temps de calcul des occurences des courbes

            def variable_count_custom(filename):
                df = pa.read_parquet('/p/SLM_files/parquets/'+filename)
                return df.columns

            files = os.listdir('/p/SLM_files/parquets')
            print('{} files, sample : '.format(len(files)), files[:10])

            # OK
            #c_count = sc.parallelize(files[0: 500]).flatMap(variable_count_custom).map(lambda x: (x, 1)).reduceByKey(lambda x, y: x + y)

            final = []

            for n in range (0, len(files), 50) :
                final += sc.parallelize(files[0+n: 50+n], 20).flatMap(variable_count_custom).map(lambda x: (x, 1)).collect() #+= car collect retourne une liste
                print("Pour n = " + str(n) + " ; ", final[:5])

            c_count = sc.parallelize(final, 20).reduceByKey(lambda x, y: x + y)

            print("Temps pour calculer les occurences des courbes :", time.time() - t1_c, "avec", nb_executor, "worker")
            print("extrait liste :", final[:20])


            # Sort by value
            print("Tri")
            t1_t = time.time()  # Temps de triage des courbes selon leurs occurences
            c_sort = c_count.sortBy(lambda x: x[1], ascending=False)
            print(c_sort.take(40))

            c_sort_map = c_sort.map(lambda x: Row(name=x[0], occurence=x[1]))
            c_sort_df = c_sort_map.toDF() # Pas optimisé (à revoir ou marqué comme amélioration dans le rapport)

            print("Temps pour trier les occurences des courbes:", time.time() - t1_t, "avec", nb_executor, "worker")

            # Parquet ou du csv ou texte
            c_sort_df.write.parquet('/p/SLM_files/c_sort',"overwrite")  # Ecriture d'un parquet depuis un DF   # 2 colonnes _1 (nom courbe) et _2 (occurence)


        if generate_curves_tables :
            # Génération d'un table par type de colonne et aggréation de toutes les colonnes de tous les fichiers dans ces tables

            t_gct = time.time()     # Temps de generation de la table des courbes

            files = os.listdir('/p/SLM_files/parquets')

            for f in files :
                print("traitement du fichiers ", f)
                df = pa.read_parquet('/p/SLM_files/parquets/' + f)

                cols = list(df.columns)

                # Récupération du nom de la colonne qui sert d'indexe (profondeur du forage)
                if 'DEPT' in cols :
                    index = 'DEPT'
                elif 'DEPTH' in cols :
                    index = 'DEPTH'
                elif 'DEPTH:1' in cols :
                    index = 'DEPTH:1'
                elif 'DEPTH:2' in cols :
                    index = 'DEPTH:2'
                else :
                    print("pas d'indices trouvé, skip. colonnes présentes : ", cols)
                    continue

                # on enlève la colonne d'indexe car on veut pas créer sa table
                cols.remove(index) # cas de multiple index non traité


                for col in cols :
                    filename = col + '.csv'

                    if filename in os.listdir('/p/SLM_files/curves') :
                        # ajout d'une colonne dans une table éxistante
                        print("append de la table ", col)
                        df_curve = pa.read_csv('/p/SLM_files/curves/' +filename, sep=';')
                        dept = list(df_curve.columns)[0]
                        df_curve = df_curve.merge(df[[index, col]], how='outer', left_on=dept , right_on=index)

                    else :
                        # création de la table
                        print('création de la table de la courbe ', col)
                        df_curve = df[[index, col]]

                    df_curve.to_csv('/p/SLM_files/curves/'+filename, sep=';') # obligé de sauvegardé en csv car parquet nécéssite un dossier par nom sinon
            
            print("Temps pour generer la table des courbes : ", time.time() - t_gct, "s avec", nb_executor, "worker")


        if q2 :
            ## Question 2 ##
            t1_q2 = time.time()     # Temps d'analyse des donnees

            curves = os.listdir('/p/SLM_files/curves')
            first_time = True

            for f in curves :
                curve_name = f.replace('.csv','')
                df_read = pa.read_csv('/p/SLM_files/curves/'+f)

                cols = list(df_read.columns)
                
                # on prend les table qui ont aux moins 5 courbes car sinon cela n'est pas intéressent et prend du temps de calcul pour rien
                if len(cols) > 6 :

                    if first_time :
                        index = cols[0]
                        df_read[curve_name] = df_read[cols[1:]].mean(axis=1)
                        df_analyse = df_read[[index, curve_name]]
                        first_time = False
                    else :
                        df_analyse[curve_name] = df_read[cols[1:]].mean(axis=1)
                else :
                    print("table {} non prise en compte".format(curve_name))

                df_analyse.to_csv('/p/SLM_files/analyse.csv', sep=';')

            print("Temps pour analyser les donnees : ", time.time() - t1_q2, "s avec", nb_executor, "worker")

    except  Exception as e:
        print(f"#| Curve-count - exception - {e}")
    finally:
        print("Temps d'execution total :", time.time() - t_global, "s avec", nb_executor, "worker")
        if spark:
            spark.stop()
